Index: /palm/trunk/SOURCE/flow_statistics.f90
===================================================================
--- /palm/trunk/SOURCE/flow_statistics.f90	(revision 2231)
+++ /palm/trunk/SOURCE/flow_statistics.f90	(revision 2232)
@@ -810,66 +893,179 @@
 !--          Subgridscale fluxes in the Prandtl layer
              IF ( use_surface_fluxes )  THEN
-                sums_l(nzb,12,tn) = sums_l(nzb,12,tn) + &
+                DO  l = 0, 1
+                   ki = MERGE( -1, 0, l == 0 )
+                   IF ( surf_def_h(l)%ns >= 1 )  THEN
+                      DO  m = surf_def_h(l)%start_index(j,i), surf_def_h(l)%end_index(j,i)
+                         k = surf_def_h(l)%k(m)
+
+                         sums_l(k+ki,12,tn) = sums_l(k+ki,12,tn) + &
+                                    momentumflux_output_conversion(k+ki) * &
+                                    surf_def_h(l)%usws(m) * rmask(j,i,sr)     ! w"u"
+                         sums_l(k+ki,14,tn) = sums_l(k+ki,14,tn) + &
+                                    momentumflux_output_conversion(k+ki) * &
+                                    surf_def_h(l)%vsws(m) * rmask(j,i,sr)     ! w"v"
+                         sums_l(k+ki,16,tn) = sums_l(k+ki,16,tn) + &
+                                    heatflux_output_conversion(k+ki) * &
+                                    surf_def_h(l)%shf(m)  * rmask(j,i,sr)     ! w"pt"
+                         sums_l(k+ki,58,tn) = sums_l(k+ki,58,tn) + &
+                                    0.0_wp * rmask(j,i,sr)        ! u"pt"
+                         sums_l(k+ki,61,tn) = sums_l(k+ki,61,tn) + &
+                                    0.0_wp * rmask(j,i,sr)        ! v"pt"
+                         IF ( ocean )  THEN
+                            sums_l(k+ki,65,tn) = sums_l(k+ki,65,tn) + &
+                                       surf_def_h(l)%sasws(m) * rmask(j,i,sr)  ! w"sa"
+                         ENDIF
+                         IF ( humidity )  THEN
+                            sums_l(k+ki,48,tn) = sums_l(k+ki,48,tn) +                     &
+                                       waterflux_output_conversion(k+ki) *      &
+                                       surf_def_h(l)%qsws(m) * rmask(j,i,sr)  ! w"q" (w"qv")
+                            sums_l(k+ki,45,tn) = sums_l(k+ki,45,tn) + (                   &
+                                       ( 1.0_wp + 0.61_wp * q(k+ki,j,i) ) *     &
+                                       surf_def_h(l)%shf(m) + 0.61_wp * pt(k+ki,j,i) *      &
+                                                  surf_def_h(l)%qsws(m) )                  &
+                                       * heatflux_output_conversion(k+ki)
+                            IF ( cloud_droplets )  THEN
+                               sums_l(k+ki,45,tn) = sums_l(k+ki,45,tn) + (                &
+                                         ( 1.0_wp + 0.61_wp * q(k+ki,j,i) -     &
+                                           ql(k+ki,j,i) ) * surf_def_h(l)%shf(m) +          &
+                                           0.61_wp * pt(k+ki,j,i) * surf_def_h(l)%qsws(m) ) &
+                                          * heatflux_output_conversion(k+ki)
+                            ENDIF
+                            IF ( cloud_physics )  THEN
+!
+!--                            Formula does not work if ql(k+ki) /= 0.0
+                               sums_l(k+ki,51,tn) = sums_l(k+ki,51,tn) +                  &
+                                          waterflux_output_conversion(k+ki) *   &
+                                          surf_def_h(l)%qsws(m) * rmask(j,i,sr) ! w"q" (w"qv")
+                            ENDIF
+                         ENDIF
+                         IF ( passive_scalar )  THEN
+                            sums_l(k+ki,119,tn) = sums_l(k+ki,119,tn) +                     &
+                                        surf_def_h(l)%ssws(m) * rmask(j,i,sr) ! w"s"
+                         ENDIF
+
+                      ENDDO
+
+                   ENDIF
+                ENDDO
+                IF ( surf_lsm_h%ns >= 1 )  THEN
+                   m = surf_lsm_h%start_index(j,i)
+                   sums_l(nzb,12,tn) = sums_l(nzb,12,tn) + &
                                     momentumflux_output_conversion(nzb) * &
-                                    usws(j,i) * rmask(j,i,sr)     ! w"u"
-                sums_l(nzb,14,tn) = sums_l(nzb,14,tn) + &
+                                    surf_lsm_h%usws(m) * rmask(j,i,sr)     ! w"u"
+                   sums_l(nzb,14,tn) = sums_l(nzb,14,tn) + &
                                     momentumflux_output_conversion(nzb) * &
-                                    vsws(j,i) * rmask(j,i,sr)     ! w"v"
-                sums_l(nzb,16,tn) = sums_l(nzb,16,tn) + &
+                                    surf_lsm_h%vsws(m) * rmask(j,i,sr)     ! w"v"
+                   sums_l(nzb,16,tn) = sums_l(nzb,16,tn) + &
                                     heatflux_output_conversion(nzb) * &
-                                    shf(j,i)  * rmask(j,i,sr)     ! w"pt"
-                sums_l(nzb,58,tn) = sums_l(nzb,58,tn) + &
+                                    surf_lsm_h%shf(m)  * rmask(j,i,sr)     ! w"pt"
+                   sums_l(nzb,58,tn) = sums_l(nzb,58,tn) + &
                                     0.0_wp * rmask(j,i,sr)        ! u"pt"
-                sums_l(nzb,61,tn) = sums_l(nzb,61,tn) + &
+                   sums_l(nzb,61,tn) = sums_l(nzb,61,tn) + &
                                     0.0_wp * rmask(j,i,sr)        ! v"pt"
-                IF ( ocean )  THEN
-                   sums_l(nzb,65,tn) = sums_l(nzb,65,tn) + &
-                                       saswsb(j,i) * rmask(j,i,sr)  ! w"sa"
-                ENDIF
-                IF ( humidity )  THEN
-                   sums_l(nzb,48,tn) = sums_l(nzb,48,tn) +                     &
+                   IF ( ocean )  THEN
+                      sums_l(nzb,65,tn) = sums_l(nzb,65,tn) + &
+                                       surf_lsm_h%sasws(m) * rmask(j,i,sr)  ! w"sa"
+                   ENDIF
+                   IF ( humidity )  THEN
+                      sums_l(nzb,48,tn) = sums_l(nzb,48,tn) +                     &
                                        waterflux_output_conversion(nzb) *      &
-                                       qsws(j,i) * rmask(j,i,sr)  ! w"q" (w"qv")
-                   sums_l(nzb,45,tn) = sums_l(nzb,45,tn) + (                   &
+                                       surf_lsm_h%qsws(m) * rmask(j,i,sr)  ! w"q" (w"qv")
+                      sums_l(nzb,45,tn) = sums_l(nzb,45,tn) + (                   &
                                        ( 1.0_wp + 0.61_wp * q(nzb,j,i) ) *     &
-                                       shf(j,i) + 0.61_wp * pt(nzb,j,i) *      &
-                                                  qsws(j,i) )                  &
+                                       surf_lsm_h%shf(m) + 0.61_wp * pt(nzb,j,i) *      &
+                                                  surf_lsm_h%qsws(m) )                  &
                                        * heatflux_output_conversion(nzb)
-                   IF ( cloud_droplets )  THEN
-                      sums_l(nzb,45,tn) = sums_l(nzb,45,tn) + (                &
+                      IF ( cloud_droplets )  THEN
+                         sums_l(nzb,45,tn) = sums_l(nzb,45,tn) + (                &
                                          ( 1.0_wp + 0.61_wp * q(nzb,j,i) -     &
-                                           ql(nzb,j,i) ) * shf(j,i) +          &
-                                           0.61_wp * pt(nzb,j,i) * qsws(j,i) ) &
+                                           ql(nzb,j,i) ) * surf_lsm_h%shf(m) +          &
+                                           0.61_wp * pt(nzb,j,i) * surf_lsm_h%qsws(m) ) &
                                           * heatflux_output_conversion(nzb)
+                      ENDIF
+                      IF ( cloud_physics )  THEN
+!
+!--                      Formula does not work if ql(nzb) /= 0.0
+                         sums_l(nzb,51,tn) = sums_l(nzb,51,tn) +                  &
+                                          waterflux_output_conversion(nzb) *   &
+                                          surf_lsm_h%qsws(m) * rmask(j,i,sr) ! w"q" (w"qv")
+                      ENDIF
                    ENDIF
-                   IF ( cloud_physics )  THEN
-!
-!--                   Formula does not work if ql(nzb) /= 0.0
-                      sums_l(nzb,51,tn) = sums_l(nzb,51,tn) +                  &
+                   IF ( passive_scalar )  THEN
+                      sums_l(nzb,119,tn) = sums_l(nzb,119,tn) +                     &
+                                        surf_lsm_h%ssws(m) * rmask(j,i,sr) ! w"s"
+                   ENDIF
+
+
+                ENDIF
+                IF ( surf_usm_h%ns >= 1 )  THEN
+                   m = surf_usm_h%start_index(j,i)
+                   sums_l(nzb,12,tn) = sums_l(nzb,12,tn) + &
+                                    momentumflux_output_conversion(nzb) * &
+                                    surf_usm_h%usws(m) * rmask(j,i,sr)     ! w"u"
+                   sums_l(nzb,14,tn) = sums_l(nzb,14,tn) + &
+                                    momentumflux_output_conversion(nzb) * &
+                                    surf_usm_h%vsws(m) * rmask(j,i,sr)     ! w"v"
+                   sums_l(nzb,16,tn) = sums_l(nzb,16,tn) + &
+                                    heatflux_output_conversion(nzb) * &
+                                    surf_usm_h%shf(m)  * rmask(j,i,sr)     ! w"pt"
+                   sums_l(nzb,58,tn) = sums_l(nzb,58,tn) + &
+                                    0.0_wp * rmask(j,i,sr)        ! u"pt"
+                   sums_l(nzb,61,tn) = sums_l(nzb,61,tn) + &
+                                    0.0_wp * rmask(j,i,sr)        ! v"pt"
+                   IF ( ocean )  THEN
+                      sums_l(nzb,65,tn) = sums_l(nzb,65,tn) + &
+                                       surf_usm_h%sasws(m) * rmask(j,i,sr)  ! w"sa"
+                   ENDIF
+                   IF ( humidity )  THEN
+                      sums_l(nzb,48,tn) = sums_l(nzb,48,tn) +                     &
+                                       waterflux_output_conversion(nzb) *      &
+                                       surf_usm_h%qsws(m) * rmask(j,i,sr)  ! w"q" (w"qv")
+                      sums_l(nzb,45,tn) = sums_l(nzb,45,tn) + (                   &
+                                       ( 1.0_wp + 0.61_wp * q(nzb,j,i) ) *     &
+                                       surf_usm_h%shf(m) + 0.61_wp * pt(nzb,j,i) *      &
+                                                  surf_usm_h%qsws(m) )                  &
+                                       * heatflux_output_conversion(nzb)
+                      IF ( cloud_droplets )  THEN
+                         sums_l(nzb,45,tn) = sums_l(nzb,45,tn) + (                &
+                                         ( 1.0_wp + 0.61_wp * q(nzb,j,i) -     &
+                                           ql(nzb,j,i) ) * surf_usm_h%shf(m) +          &
+                                           0.61_wp * pt(nzb,j,i) * surf_usm_h%qsws(m) ) &
+                                          * heatflux_output_conversion(nzb)
+                      ENDIF
+                      IF ( cloud_physics )  THEN
+!
+!--                      Formula does not work if ql(nzb) /= 0.0
+                         sums_l(nzb,51,tn) = sums_l(nzb,51,tn) +                  &
                                           waterflux_output_conversion(nzb) *   &
-                                          qsws(j,i) * rmask(j,i,sr) ! w"q" (w"qv")
+                                          surf_usm_h%qsws(m) * rmask(j,i,sr) ! w"q" (w"qv")
+                      ENDIF
                    ENDIF
-                ENDIF
-                IF ( passive_scalar )  THEN
-                   sums_l(nzb,119,tn) = sums_l(nzb,119,tn) +                     &
-                                        ssws(j,i) * rmask(j,i,sr) ! w"s"
-                ENDIF
+                   IF ( passive_scalar )  THEN
+                      sums_l(nzb,119,tn) = sums_l(nzb,119,tn) +                     &
+                                        surf_usm_h%ssws(m) * rmask(j,i,sr) ! w"s"
+                   ENDIF
+
+
+                ENDIF
+
              ENDIF
 
              IF ( .NOT. neutral )  THEN
-                sums_l(nzb,114,tn) = sums_l(nzb,114,tn) +                      &
-                                    ol(j,i)  * rmask(j,i,sr) ! L
-             ENDIF
-
-
-             IF ( land_surface )  THEN
-                sums_l(nzb,93,tn)  = sums_l(nzb,93,tn) + ghf_eb(j,i)
-                sums_l(nzb,94,tn)  = sums_l(nzb,94,tn) + shf_eb(j,i)
-                sums_l(nzb,95,tn)  = sums_l(nzb,95,tn) + qsws_eb(j,i)
-                sums_l(nzb,96,tn)  = sums_l(nzb,96,tn) + qsws_liq_eb(j,i)
-                sums_l(nzb,97,tn)  = sums_l(nzb,97,tn) + qsws_soil_eb(j,i)
-                sums_l(nzb,98,tn)  = sums_l(nzb,98,tn) + qsws_veg_eb(j,i)
-                sums_l(nzb,99,tn)  = sums_l(nzb,99,tn) + r_a(j,i)
-                sums_l(nzb,100,tn) = sums_l(nzb,100,tn)+ r_s(j,i)
+                IF ( surf_def_h(0)%ns >= 1 )  THEN
+                   m = surf_def_h(0)%start_index(j,i)
+                   sums_l(nzb,114,tn) = sums_l(nzb,114,tn) +                      &
+                                        surf_def_h(0)%ol(m)  * rmask(j,i,sr) ! L
+                ENDIF
+                IF ( surf_lsm_h%ns >= 1 )  THEN
+                   m = surf_lsm_h%start_index(j,i)
+                   sums_l(nzb,114,tn) = sums_l(nzb,114,tn) +                      &
+                                        surf_lsm_h%ol(m)  * rmask(j,i,sr) ! L
+                ENDIF
+                IF ( surf_usm_h%ns >= 1 )  THEN
+                   m = surf_usm_h%start_index(j,i)
+                   sums_l(nzb,114,tn) = sums_l(nzb,114,tn) +                      &
+                                        surf_usm_h%ol(m)  * rmask(j,i,sr) ! L
+                ENDIF
              ENDIF
 
@@ -893,13 +1089,14 @@
 !--          Subgridscale fluxes at the top surface
              IF ( use_top_fluxes )  THEN
+                m = surf_def_h(2)%start_index(j,i)
                 sums_l(nzt:nzt+1,12,tn) = sums_l(nzt:nzt+1,12,tn) + &
                                     momentumflux_output_conversion(nzt:nzt+1) * &
-                                    uswst(j,i) * rmask(j,i,sr)    ! w"u"
+                                    surf_def_h(2)%usws(m) * rmask(j,i,sr)    ! w"u"
                 sums_l(nzt:nzt+1,14,tn) = sums_l(nzt:nzt+1,14,tn) + &
                                     momentumflux_output_conversion(nzt:nzt+1) * &
-                                    vswst(j,i) * rmask(j,i,sr)    ! w"v"
+                                    surf_def_h(2)%vsws(m) * rmask(j,i,sr)    ! w"v"
                 sums_l(nzt:nzt+1,16,tn) = sums_l(nzt:nzt+1,16,tn) + &
                                     heatflux_output_conversion(nzt:nzt+1) * &
-                                    tswst(j,i)  * rmask(j,i,sr)   ! w"pt"
+                                    surf_def_h(2)%shf(m)  * rmask(j,i,sr)   ! w"pt"
                 sums_l(nzt:nzt+1,58,tn) = sums_l(nzt:nzt+1,58,tn) + &
                                     0.0_wp * rmask(j,i,sr)        ! u"pt"
@@ -909,20 +1106,23 @@
                 IF ( ocean )  THEN
                    sums_l(nzt,65,tn) = sums_l(nzt,65,tn) + &
-                                       saswst(j,i) * rmask(j,i,sr)  ! w"sa"
+                                       surf_def_h(2)%sasws(m) * rmask(j,i,sr)  ! w"sa"
                 ENDIF
                 IF ( humidity )  THEN
                    sums_l(nzt,48,tn) = sums_l(nzt,48,tn) +                     &
                                        waterflux_output_conversion(nzt) *      &
-                                       qswst(j,i) * rmask(j,i,sr) ! w"q" (w"qv")
+                                       surf_def_h(2)%qsws(m) * rmask(j,i,sr) ! w"q" (w"qv")
                    sums_l(nzt,45,tn) = sums_l(nzt,45,tn) + (                   &
                                        ( 1.0_wp + 0.61_wp * q(nzt,j,i) ) *     &
-                                       tswst(j,i) + 0.61_wp * pt(nzt,j,i) *    &
-                                                             qswst(j,i) )      &
+                                       surf_def_h(2)%shf(m) +                  &
+                                       0.61_wp * pt(nzt,j,i) *    &
+                                       surf_def_h(2)%qsws(m) )      &
                                        * heatflux_output_conversion(nzt)
                    IF ( cloud_droplets )  THEN
                       sums_l(nzt,45,tn) = sums_l(nzt,45,tn) + (                &
                                           ( 1.0_wp + 0.61_wp * q(nzt,j,i) -    &
-                                            ql(nzt,j,i) ) * tswst(j,i) +       &
-                                           0.61_wp * pt(nzt,j,i) * qswst(j,i) )&
+                                            ql(nzt,j,i) ) *                    &
+                                            surf_def_h(2)%shf(m) +             &
+                                           0.61_wp * pt(nzt,j,i) *             &
+                                           surf_def_h(2)%qsws(m) )&
                                            * heatflux_output_conversion(nzt)
                    ENDIF
@@ -932,10 +1132,10 @@
                       sums_l(nzt,51,tn) = sums_l(nzt,51,tn) + &   ! w"q" (w"qv")
                                           waterflux_output_conversion(nzt) *   &
-                                          qswst(j,i) * rmask(j,i,sr)
+                                          surf_def_h(2)%qsws(m) * rmask(j,i,sr)
                    ENDIF
                 ENDIF
                 IF ( passive_scalar )  THEN
                    sums_l(nzt,119,tn) = sums_l(nzt,119,tn) + &
-                                        sswst(j,i) * rmask(j,i,sr) ! w"s"
+                                        surf_def_h(2)%ssws(m) * rmask(j,i,sr) ! w"s"
                 ENDIF
              ENDIF
@@ -946,5 +1146,6 @@
 !--          ----  speaking the following k-loop would have to be split up and 
 !--                rearranged according to the staggered grid.
-             DO  k = nzb_s_inner(j,i), nzt
+             DO  k = nzb, nzt
+                flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 22 ) )
                 ust = 0.5_wp * ( u(k,j,i)   - hom(k,1,1,sr) +                  &
                                  u(k+1,j,i) - hom(k+1,1,1,sr) )
@@ -956,7 +1157,7 @@
 !--             Higher moments
                 sums_l(k,35,tn) = sums_l(k,35,tn) + pts * w(k,j,i)**2 *        &
-                                                    rmask(j,i,sr)
+                                                    rmask(j,i,sr) * flag
                 sums_l(k,36,tn) = sums_l(k,36,tn) + pts**2 * w(k,j,i) *        &
-                                                    rmask(j,i,sr)
+                                                    rmask(j,i,sr) * flag
 
 !
@@ -968,10 +1169,10 @@
                                        sa(k+1,j,i) - hom(k+1,1,23,sr) )
                       sums_l(k,66,tn) = sums_l(k,66,tn) + pts * w(k,j,i) *     &
-                                        rmask(j,i,sr)
+                                        rmask(j,i,sr) * flag
                    ENDIF
-                   sums_l(k,64,tn) = sums_l(k,64,tn) + rho_ocean(k,j,i) *            &
-                                                       rmask(j,i,sr)
+                   sums_l(k,64,tn) = sums_l(k,64,tn) + rho_ocean(k,j,i) *      &
+                                                       rmask(j,i,sr) * flag
                    sums_l(k,71,tn) = sums_l(k,71,tn) + prho(k,j,i) *           &
-                                                       rmask(j,i,sr)
+                                                       rmask(j,i,sr) * flag
                 ENDIF
 
@@ -985,6 +1186,7 @@
                       sums_l(k,46,tn) = sums_l(k,46,tn) + pts * w(k,j,i) *     &
                                                heatflux_output_conversion(k) * &
-                                                          rmask(j,i,sr)
-                      sums_l(k,54,tn) = sums_l(k,54,tn) + ql(k,j,i) * rmask(j,i,sr)
+                                                          rmask(j,i,sr) * flag
+                      sums_l(k,54,tn) = sums_l(k,54,tn) + ql(k,j,i) * rmask(j,i,sr) &
+                                                                    * flag
 
                       IF ( .NOT. cloud_droplets )  THEN
@@ -996,14 +1198,19 @@
                          sums_l(k,52,tn) = sums_l(k,52,tn) + pts * w(k,j,i) *  &
                                              waterflux_output_conversion(k) *  &
-                                                             rmask(j,i,sr)
+                                                             rmask(j,i,sr)  *  &
+                                                             flag
                          sums_l(k,75,tn) = sums_l(k,75,tn) + qc(k,j,i) *       &
-                                                             rmask(j,i,sr)
+                                                             rmask(j,i,sr) *   &
+                                                             flag
                          sums_l(k,76,tn) = sums_l(k,76,tn) + prr(k,j,i) *      &
-                                                             rmask(j,i,sr)
+                                                             rmask(j,i,sr) *   &
+                                                             flag
                          IF ( microphysics_seifert )  THEN
                             sums_l(k,73,tn) = sums_l(k,73,tn) + nr(k,j,i) *    &
-                                                                rmask(j,i,sr)
+                                                                rmask(j,i,sr) *&
+                                                                flag 
                             sums_l(k,74,tn) = sums_l(k,74,tn) + qr(k,j,i) *    &
-                                                                rmask(j,i,sr)
+                                                                rmask(j,i,sr) *&
+                                                                flag
                          ENDIF
                       ENDIF
@@ -1015,5 +1222,6 @@
                          sums_l(k,46,tn) = sums_l(k,46,tn) + pts * w(k,j,i) *  &
                                               heatflux_output_conversion(k) *  &
-                                                             rmask(j,i,sr)
+                                                             rmask(j,i,sr)  *  &
+                                                             flag
                       ELSE IF ( ws_scheme_sca .AND. sr == 0 )  THEN
                          sums_l(k,46,tn) = ( ( 1.0_wp + 0.61_wp *              & 
@@ -1022,5 +1230,6 @@
                                              0.61_wp * hom(k,1,4,sr) *         &
                                              sums_l(k,49,tn)                   &
-                                           ) * heatflux_output_conversion(k)
+                                           ) * heatflux_output_conversion(k) * &
+                                               flag
                       END IF
                    END IF
@@ -1033,5 +1242,5 @@
                                     s(k+1,j,i) - hom(k+1,1,117,sr) )
                    sums_l(k,116,tn) = sums_l(k,116,tn) + pts * w(k,j,i) *      &
-                                                       rmask(j,i,sr)
+                                                       rmask(j,i,sr) * flag
                 ENDIF
 
